//			Copyright (c) 1993 by
//			Advanced Visual Systems Inc.
//			All Rights Reserved
//
//	This software comprises unpublished confidential information of
//	Advanced Visual Systems Inc. and may not be used, copied or made
//	available to anyone, except in accordance with the license
//	under which it is furnished.
//
//	This file is under Perforce control
//	$Id: //depot/express/fcs992/include/avs/ag/geometry.hxx#1 $
//

// geometry.hxx - Header file for AgGeometry class

//----------------------------------------------------------------------
#ifndef AG_GEOMETRY_HXX
#define AG_GEOMETRY_HXX

#ifndef CXXUTIL_MISC_HXX
#include <avs/cxxutl/misc.hxx>
#endif

#ifndef CXXUTIL_ARRAY_HXX
#include <avs/cxxutl/array.hxx>
#endif

#include <avs/port.h>

#ifdef IRIX6_OBSOLETE
#define AGFLOAT double
#else
#define AGFLOAT float
#endif

//----------------------------------------------------------------------
// Class to represent a Toolmaster++ Geometry
//----------------------------------------------------------------------
class AgGeometry 
//----------------------------------------------------------------------
{
  public:
    AgGeometry();
    AgGeometry(AGFLOAT *geometryX,
               AGFLOAT *geometryY,
               int numCoordinates);
    AgGeometry(float *geometryXY, 
               int numPairs) ;
    AgGeometry(double *geometryXY, 
               int numPairs) ;
    AgGeometry(UtArray<AGFLOAT> geometryXY);
    AgGeometry(UtArray<AGFLOAT> geometryX, UtArray<AGFLOAT> geometryY);
    
    void set(float *geometryXY, 
             int numPairs);
    void set(double *geometryXY, 
             int numPairs);

    void set(UtArray<AGFLOAT> &geometryXY);

    void set(UtArray<AGFLOAT> &geometryX, UtArray<AGFLOAT> &geometryY);

    void set(AGFLOAT *geometryX,
             AGFLOAT *geometryY,
             int numCoordinates);

    AGFLOAT *getXData() const {
        return _geometryX.data();
    }   

    AGFLOAT *getYData() const {
        return _geometryY.data();
    }   

    UtArray<AGFLOAT> &getX() {
        return _geometryX;
    }

    UtArray<AGFLOAT> &getY() {
        return _geometryY;
    }

    int numCoordinates() const {
        return _geometryX.size();
    }

  private:

    UtArray<AGFLOAT> _geometryX;
    UtArray<AGFLOAT> _geometryY;
};
#endif

